@REM V1.00 2024/09/26 SMC Corp.

@cd /d %~dp0

@mkdir root\certs root\crl root\newcerts root\private root\csr
@type nul > root\index.txt
@echo 00 > root\crlnumber
@echo 1000 > root\serial
@echo testpass > root\passphrase

@mkdir server\certs server\crl server\newcerts server\private server\csr
@type nul > server\index.txt
@type nul > server\crlnumber
@echo 1000 > server\serial
@echo testpass > server\passphrase

@set /p CA_CERT="Input CA Certificate Name: "
@set CA_KEY=%CA_CERT%_key

@openssl genrsa -passout pass:root\passphrase -aes256 -out root\private\%CA_KEY%.pem 2048

@REM delete passphrase
@openssl rsa -passin pass:root\passphrase -in root\private\%CA_KEY%.pem -out root\private\%CA_KEY%.pem
 
@openssl req -new -x509 -days 3650 -sha256 -key root\private\%CA_KEY%.pem -out root\certs\%CA_CERT%.pem -config openssl.cfg -extensions v3_ca

@openssl x509 -in root\certs\%CA_CERT%.pem -inform PEM -out root\certs\%CA_CERT%.der -outform DER
@openssl crl2pkcs7 -nocrl -certfile root\certs\%CA_CERT%.pem -out root\certs\%CA_CERT%.p7b

@openssl ca -gencrl -crldays 3650 -cert root\certs\%CA_CERT%.pem -keyfile root\private\%CA_KEY%.pem -config openssl.cfg -out root\crl\crl.pem
@openssl crl -in root\crl\crl.pem -inform PEM -out root\crl\crl.crl -outform DER

@pause

