@REM V1.00 2024/09/26 SMC Corp.

@cd /d %~dp0

@del root\index.txt
@type nul > root\index.txt

@set /p CA_CERT="Input CA Certificate Name: "
@set CA_KEY=%CA_CERT%_key

@set /p DEV_CERT="Input Device Certificate Name: "
@set DEV_KEY=%DEV_CERT%_key
@set DEV_CSR=%DEV_CERT%_csr

@set CERT_DAYS=825
@set /p CERT_SAN="Input Device IP Address: "
@type nul > device.cfg
@echo [ req ] >> device.cfg
@echo default_bits       = 2048 >> device.cfg
@echo distinguished_name = req_distinguished_name >> device.cfg
@echo req_extensions     = req_ext >> device.cfg
@echo [ req_distinguished_name ] >> device.cfg
@echo countryName                 = Country Name (2 letter code) >> device.cfg
@echo stateOrProvinceName         = State or Province Name (full name) >> device.cfg
@echo localityName                = Locality Name (eg, city) >> device.cfg
@echo organizationName            = Organization Name (eg, company) >> device.cfg
@echo commonName                  = Common Name (e.g. server FQDN or YOUR name) >> device.cfg
@echo [ req_ext ] >> device.cfg
@echo subjectAltName = @alt_names >> device.cfg
@echo [ alt_names ] >> device.cfg
@echo DNS.1   = *.ex600.smc >> device.cfg
@echo URI.1   = urn:ex600.smc >> device.cfg
@echo IP.1	= %CERT_SAN% >> device.cfg

@openssl genrsa -passout pass:server\passphrase -aes256 -out server\private\%DEV_KEY%.pem 2048

@openssl rsa -passin pass:server\passphrase -in server\private\%DEV_KEY%.pem -out server\private\%DEV_KEY%.pem

@openssl req -new -sha256 -key server\private\%DEV_KEY%.pem -out server\csr\%DEV_CSR%.pem -config device.cfg

@openssl req -noout -text -in server\csr\%DEV_CSR%.pem

@openssl ca -days %CERT_DAYS% -notext -md sha256 -cert root\certs\%CA_CERT%.pem -keyfile root\private\%CA_KEY%.pem -in server\csr\%DEV_CSR%.pem -out server\certs\%DEV_CERT%.pem -config openssl.cfg -extensions server_cert

@openssl x509 -outform der -in server\certs\%DEV_CERT%.pem -out server\certs\%DEV_CERT%.pem.der

@del device.cfg

@pause
